#ifndef BARRIER_H_
#define BARRIER_H_

#include <pthread.h>

#ifdef __cplusplus
/* If being compiled with C++, add 'extern "C"' to each of these functions.
 * 
 * This makes it possible to use this header file from both C and C++
 * and to implement the barrier library in either C or C++.
 */
#define EXTERN_C extern "C"
#endif

/* my_barrier is an alias for a struct my_barrier. The struct is deliberately
 * not defined here because users of the barrier library are only supposed
 * to access it via the barrier_* functions, which all take a pointer to an
 * instance of this struct.
 *
 * You can, in your implementation, do something like:
 *   struct my_barrier {
 *     int thread_count;
 *     ... // whatever else you need for your implementation
 *   };
 * 
 * And then given a my_barrier *b, access b->thread_count and so on.
 */
typedef struct my_barrier my_barrier;

EXTERN_C my_barrier *barrier_create(int num_threads);
EXTERN_C void barrier_wait(my_barrier *);
EXTERN_C void barrier_destroy(my_barrier *);

#endif
